/*!
 * @brief run control module
 * $Date$
 * @author Nemoto,Mizoguchi lab,Tokyo University of Science
 * @mail:j7507640@ed.noda.tus.ac.jp
 * $Id$
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream>
using namespace std;
#include "pathplan.h"

void arc_tan2(double &target_x,double &target_y,double &theta){
    double target_r = sqrt(target_x*target_x+target_y*target_y);
 
    if(target_y>=0){
	theta=acos(target_x/target_r);
	theta=theta*180.0/PI;
    }
    else if(target_y<0){
	theta=acos(target_x/target_r);
	theta=360.0-theta*180.0/PI;
    }
    
    if(theta>=90.0)      theta=theta-90.0;
    else if(theta<90.0)  theta=theta-90.0;
    if(theta>180.0) theta=theta-360.0;

}


void follow_velocity(double goal_x,double goal_y,double robot_x,double robot_y,double &speed,double &turn){

    double urg_x=goal_x - robot_x;
    double urg_y=goal_y - robot_y; 
    double urg_l=sqrt(goal_x*goal_x+goal_y*goal_y);
    double urg_deg=(-1)*atan2(urg_x,urg_y);

    double x=urg_l;
    speed = 0.0246*pow(x,4) - 0.1987*pow(x,3) + 0.169*pow(x,2) + 1.7482*pow(x,1) - 1.3423;
    x=fabs(urg_deg);
    turn = -0.0278*pow(x,5) + 0.3025*pow(x,4) - 1.1232*pow(x,3) + 1.4103*pow(x,2) + 0.4428*pow(x,1) + 0.0365;
    if(urg_deg<0) turn=-turn;
    else if(urg_deg>=0) turn=turn;
    
}



